
song = nil
auto_checkmark = false

function song_obs()
  song = renoise.song()
  if auto_checkmark then
   auto_collapse_toggle()
  end  
end

if pcall(function() return renoise.song() end) then
  song = renoise.song() -- catching installation scenario
end

function collapse_empty_tracks()
  for track_idx, pat_track in ipairs(song:pattern(song.selected_pattern_index).tracks) do
    song:track(track_idx).collapsed = pat_track.is_empty
  end   
end

function auto_collapse_toggle()
 if song.selected_pattern_index_observable:has_notifier(collapse_empty_tracks) then
  song.selected_pattern_index_observable:remove_notifier(collapse_empty_tracks)
  auto_checkmark = false
 else
  song.selected_pattern_index_observable:add_notifier(collapse_empty_tracks)
  auto_checkmark = true
  collapse_empty_tracks()
 end
end

renoise.tool().app_new_document_observable:add_notifier(song_obs)

-- Menu entries

renoise.tool():add_menu_entry {
  name = "Pattern Editor:Auto-collapse Empty Tracks",
  invoke = auto_collapse_toggle,
  selected = function() return auto_checkmark end
}

renoise.tool():add_menu_entry {
  name = "Pattern Editor:Pattern:Collapse Empty Tracks",
  invoke = collapse_empty_tracks
}

-- Keybinding

renoise.tool():add_keybinding {
  name = "Pattern Editor:Options:Collapse Empty Tracks",
  invoke = collapse_empty_tracks
}

renoise.tool():add_keybinding {
  name = "Pattern Editor:Options:Toggle Auto-Collapse tracks on/off",
  invoke = auto_collapse_toggle
}
